﻿Imports Microsoft.Reporting.WinForms

Public Class Berichtsverwaltung
    Dim Berichte As New List(Of String) From {{"2 unabhängige Tabellen in einen Bericht"},
                                              {"Bericht und Unterbericht"},
                                              {"Master-Bericht und Unterbericht als Detail"},
                                              {"Drillthrough Bericht"}}

    Private Sub Berichtsverwaltung_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        'Me.PersonalTableAdapter.Fill(Me.NordwindDataSet.Personal)
        'Me.ArtikelTableAdapter.Fill(Me.NordwindDataSet.Artikel)
        'Me.KategorienTableAdapter.Fill(Me.NordwindDataSet.Kategorien)
        'Me.KundenTableAdapter.Fill(Me.NordwindDataSet.Kunden)
        'Me.LieferantenTableAdapter.Fill(Me.NordwindDataSet.Lieferanten)
        NordwindDataSet.ReadXml("..\..\Nordwind.xml")
    End Sub

    Private Sub Berichtsverwaltung_Shown(sender As System.Object, e As System.EventArgs) Handles MyBase.Shown
        AddHandler ReportViewer1.LocalReport.SubreportProcessing, AddressOf updateSubReport
        cbxBerichte.Items.AddRange(Berichte.ToArray)
        cbxBerichte.SelectedIndex = 0
    End Sub

    Private Sub cbxBerichte_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) _
        Handles cbxBerichte.SelectedIndexChanged,
                cbxOrt.SelectedIndexChanged,
                cbxKategorie.SelectedIndexChanged
        Select Case True
            Case sender Is cbxBerichte
                cbxOrt.Items.Clear()
                cbxOrt.Text = String.Empty
                cbxKategorie.Items.Clear()
                cbxKategorie.Text = String.Empty
                KategorienBindingSource.RemoveFilter()
                Dim Bericht As String = getItem(CType(sender, ComboBox))
                Select Case Bericht
                    Case Is = "2 unabhängige Tabellen in einen Bericht"
                        Dim L1 = From x In NordwindDataSet.Kunden Select x.Ort
                        Dim L2 = From x In NordwindDataSet.Lieferanten Select x.Ort
                        cbxOrt.Items.AddRange(L1.Intersect(L2).ToArray)
                        cbxOrt.SelectedIndex = 0
                    Case Is = "Bericht und Unterbericht"
                        bindReport(Bericht, "Lieferanten", LieferantenBindingSource)
                    Case Is = "Master-Bericht und Unterbericht als Detail"
                        Dim L1 = From x In NordwindDataSet.Kategorien Select Nummer = x.KategorieNr.ToString
                        cbxKategorie.Items.AddRange(L1.Distinct.ToArray)
                        cbxKategorie.SelectedIndex = 0
                        bindReport(Bericht, "Kategorie", KategorienBindingSource)
                    Case Is = "Drillthrough Bericht"
                        bindReport(Bericht, "Kategorie", KategorienBindingSource)
                End Select
            Case sender Is cbxOrt
                Dim pOrt As New ReportParameter("rpOrt", getItem(CType(sender, ComboBox)))
                With ReportViewer1
                    .LocalReport.DataSources.Clear()
                    .LocalReport.DataSources.Add(New ReportDataSource("Kunden", KundenBindingSource))
                    .LocalReport.DataSources.Add(New ReportDataSource("Lieferanten", LieferantenBindingSource))
                    .LocalReport.ReportEmbeddedResource = String.Concat("ReportViewer_Unterberichte.Report ", "2 unabhängige Tabellen in einen Bericht", ".rdlc")
                    .LocalReport.SetParameters(New ReportParameter() {pOrt})
                    .RefreshReport()
                End With
            Case sender Is cbxKategorie
                KategorienBindingSource.Filter = String.Concat("KategorieNr = ", getItem(CType(sender, ComboBox)))
                ReportViewer1.RefreshReport()
        End Select
    End Sub

    Private Sub updateSubReport(sender As Object, e As SubreportProcessingEventArgs)
        Dim rep = CType(sender, LocalReport).ReportEmbeddedResource
        e.DataSources.Clear()
        Select Case True
            Case rep.Contains("Master-Bericht und Unterbericht")
                e.DataSources.Add(New ReportDataSource("Artikel", ArtikelBindingSource))
            Case rep.Contains("Bericht und Unterbericht")
                e.DataSources.Add(New ReportDataSource("Personal", PersonalBindingSource))
        End Select
    End Sub
    
    Private Sub ReportViewer1_Drillthrough(sender As System.Object, e As Microsoft.Reporting.WinForms.DrillthroughEventArgs) Handles ReportViewer1.Drillthrough
        CType(e.Report, LocalReport).DataSources.Add(New ReportDataSource("Artikel", ArtikelBindingSource))
    End Sub

    Private Sub bindReport(BerichtName As String, TableName As String, DataSource As Object)
        Dim rds As ReportDataSource = New ReportDataSource()
        rds.Name = TableName
        rds.Value = DataSource
        With ReportViewer1
            .LocalReport.DataSources.Clear()
            .LocalReport.DataSources.Add(rds)
            .LocalReport.ReportEmbeddedResource = String.Concat("ReportViewer_Unterberichte.Report ", BerichtName, ".rdlc")
            .RefreshReport()
        End With
    End Sub

    Private Function getItem(cbx As ComboBox) As String
        If cbx.SelectedItem Is Nothing Then Return String.Empty Else Return cbx.SelectedItem.ToString
    End Function

End Class
